#
# -*- coding: utf-8 -*-
# Copyright 2020 Red Hat
# GNU General Public License v3.0+
# (see COPYING or https://www.gnu.org/licenses/gpl-3.0.txt)

#############################################
#                WARNING                    #
#############################################
#
# This file is auto generated by the resource
#   module builder playbook.
#
# Do not edit this file manually.
#
# Changes to this file will be over written
#   by the resource module builder.
#
# Changes should be made in the model used to
#   generate this file or in the resource module
#   builder template.
#
#############################################
"""
The arg spec for the junos_bgp_global module
"""
from __future__ import absolute_import, division, print_function

__metaclass__ = type


class Bgp_globalArgs(object):  # pylint: disable=R0903
    """The arg spec for the junos_bgp_global module
    """

    def __init__(self, **kwargs):
        pass

    argument_spec = {
        "config": {
            "options": {
                "accept_remote_nexthop": {"type": "bool"},
                "add_path_display_ipv4_address": {"type": "bool"},
                "advertise_bgp_static": {
                    "options": {
                        "policy": {"type": "str"},
                        "set": {"type": "bool"},
                    },
                    "type": "dict",
                },
                "advertise_external": {
                    "options": {
                        "conditional": {"type": "bool"},
                        "set": {"type": "bool"},
                    },
                    "type": "dict",
                },
                "advertise_from_main_vpn_tables": {"type": "bool"},
                "advertise_inactive": {"type": "bool"},
                "advertise_peer_as": {"type": "bool"},
                "as_number": {"type": "str"},
                "authentication_algorithm": {
                    "choices": ["aes-128-cmac-96", "hmac-sha-1-96", "md5"],
                    "type": "str",
                },
                "authentication_key": {"type": "str"},
                "authentication_key_chain": {"type": "str"},
                "bfd_liveness_detection": {
                    "options": {
                        "authentication": {
                            "options": {
                                "algorithm": {
                                    "choices": [
                                        "keyed-md5",
                                        "keyed-sha-1",
                                        "meticulous-keyed-md5",
                                        "meticulous-keyed-sha-1",
                                        "simple-password",
                                    ],
                                    "type": "str",
                                },
                                "key_chain": {"type": "str"},
                                "loose_check": {"type": "bool"},
                            },
                            "type": "dict",
                        },
                        "detection_time": {
                            "options": {"threshold": {"type": "int"}},
                            "type": "dict",
                        },
                        "holddown_interval": {"type": "int"},
                        "minimum_interval": {"type": "int"},
                        "minimum_receive_interval": {"type": "int"},
                        "multiplier": {"type": "int"},
                        "no_adaptation": {"type": "bool"},
                        "session_mode": {
                            "choices": ["automatic", "multihop", "single-hop"],
                            "type": "str",
                        },
                        "transmit_interval": {
                            "options": {
                                "minimum_interval": {"type": "int"},
                                "threshold": {"type": "int"},
                            },
                            "type": "dict",
                        },
                        "version": {
                            "choices": ["0", "1", "automatic"],
                            "type": "str",
                        },
                    },
                    "type": "dict",
                },
                "bgp_error_tolerance": {
                    "options": {
                        "malformed_route_limit": {"type": "int"},
                        "malformed_update_log_interval": {"type": "int"},
                        "no_malformed_route_limit": {"type": "bool"},
                        "set": {"type": "bool"},
                    },
                    "type": "dict",
                },
                "bmp": {
                    "options": {
                        "monitor": {"type": "bool"},
                        "route_monitoring": {
                            "options": {
                                "none": {"type": "bool"},
                                "post_policy": {"type": "bool"},
                                "post_policy_exclude_non_eligible": {
                                    "type": "bool"
                                },
                                "post_policy_exclude_non_feasible": {
                                    "type": "bool"
                                },
                                "pre_policy": {"type": "bool"},
                            },
                            "type": "dict",
                        },
                    },
                    "type": "dict",
                },
                "cluster_id": {"type": "str"},
                "damping": {"type": "bool"},
                "description": {"type": "str"},
                "disable": {"type": "bool"},
                "egress_te": {
                    "options": {"backup_path": {"type": "str"}},
                    "type": "dict",
                },
                "egress_te_backup_paths": {
                    "options": {
                        "peer_addr": {"type": "str"},
                        "remote_nexthop": {"type": "str"},
                        "template": {
                            "options": {
                                "ip_forward": {
                                    "options": {
                                        "rti_name": {"type": "str"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "path_name": {"type": "str"},
                            },
                            "type": "dict",
                        },
                    },
                    "type": "dict",
                },
                "egress_te_set_segment": {
                    "options": {
                        "egress_te_backup_segment_label": {"type": "int"},
                        "label": {"type": "int"},
                        "name": {"type": "str"},
                    },
                    "type": "dict",
                },
                "egress_te_sid_stats": {"type": "bool"},
                "enforce_first_as": {"type": "bool"},
                "export": {"type": "str"},
                "forwarding_context": {"type": "str"},
                "graceful_restart": {
                    "options": {
                        "disable": {"type": "bool"},
                        "dont_help_shared_fate_bfd_down": {"type": "bool"},
                        "forwarding_state_bit": {
                            "options": {
                                "as_rr_client": {"type": "bool"},
                                "from_fib": {"type": "bool"},
                            },
                            "type": "dict",
                        },
                        "long_lived": {
                            "options": {
                                "advertise_to_non_llgr_neighbor": {
                                    "options": {
                                        "omit_no_export": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "receiver_disable": {"type": "bool"},
                            },
                            "type": "dict",
                        },
                        "restart_time": {"type": "int"},
                        "set": {"type": "bool"},
                        "stale_routes_time": {"type": "int"},
                    },
                    "type": "dict",
                },
                "hold_time": {"type": "int"},
                "holddown_all_stale_labels": {"type": "bool"},
                "idle_after_switch_over": {
                    "options": {
                        "forever": {"type": "bool"},
                        "timeout": {"type": "int"},
                    },
                    "type": "dict",
                },
                "import": {"type": "str"},
                "include_mp_next_hop": {"type": "bool"},
                "ipsec_sa": {"type": "str"},
                "keep": {"choices": ["all", "none"], "type": "str"},
                "local_address": {"type": "str"},
                "local_as": {
                    "options": {
                        "alias": {"type": "bool"},
                        "as_num": {"type": "str"},
                        "loops": {"type": "int"},
                        "no_prepend_global_as": {"type": "bool"},
                        "private": {"type": "bool"},
                        "set": {"type": "bool"},
                    },
                    "type": "dict",
                },
                "local_interface": {"type": "str"},
                "local_preference": {"type": "str"},
                "log_updown": {"type": "bool"},
                "metric_out": {
                    "options": {
                        "igp": {
                            "options": {
                                "delay_med_update": {"type": "bool"},
                                "metric_offset": {"type": "int"},
                                "set": {"type": "bool"},
                            },
                            "type": "dict",
                        },
                        "metric_value": {"type": "int"},
                        "minimum_igp": {
                            "options": {
                                "metric_offset": {"type": "int"},
                                "set": {"type": "bool"},
                            },
                            "type": "dict",
                        },
                    },
                    "type": "dict",
                },
                "mtu_discovery": {"type": "bool"},
                "multihop": {
                    "options": {
                        "no_nexthop_change": {"type": "bool"},
                        "set": {"type": "bool"},
                        "ttl": {"type": "int"},
                    },
                    "type": "dict",
                },
                "multipath": {
                    "options": {
                        "disable": {"type": "bool"},
                        "multiple_as": {"type": "bool"},
                        "set": {"type": "bool"},
                    },
                    "type": "dict",
                },
                "multipath_build_priority": {
                    "choices": ["low", "medium"],
                    "type": "str",
                },
                "no_advertise_peer_as": {"type": "bool"},
                "no_aggregator_id": {"type": "bool"},
                "no_client_reflect": {"type": "bool"},
                "no_precision_timers": {"type": "bool"},
                "out_delay": {"type": "int"},
                "outbound_route_filter": {
                    "options": {
                        "bgp_orf_cisco_mode": {"type": "bool"},
                        "prefix_based": {
                            "options": {
                                "accept": {
                                    "options": {
                                        "inet": {"type": "bool"},
                                        "inet6": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "set": {"type": "bool"},
                            },
                            "type": "dict",
                        },
                    },
                    "type": "dict",
                },
                "output_queue_priority": {
                    "options": {
                        "defaults": {
                            "options": {
                                "high": {
                                    "options": {
                                        "expedited": {"type": "bool"},
                                        "priority": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "low": {
                                    "options": {
                                        "expedited": {"type": "bool"},
                                        "priority": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "medium": {
                                    "options": {
                                        "expedited": {"type": "bool"},
                                        "priority": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                            },
                            "type": "dict",
                        },
                        "expedited": {
                            "options": {
                                "set": {"type": "bool"},
                                "update_tokens": {"type": "int"},
                            },
                            "type": "dict",
                        },
                        "priority": {"type": "int"},
                    },
                    "type": "dict",
                },
                "passive": {"type": "bool"},
                "path_selection": {
                    "options": {
                        "always_compare_med": {"type": "bool"},
                        "as_path_ignore": {"type": "bool"},
                        "cisco_non_deterministic": {"type": "bool"},
                        "external_router_id": {"type": "bool"},
                        "l2vpn_use_bgp_rules": {"type": "bool"},
                        "med_plus_igp": {
                            "options": {
                                "igp_multiplier": {"type": "int"},
                                "med_multiplier": {"type": "int"},
                            },
                            "type": "dict",
                        },
                    },
                    "type": "dict",
                },
                "peer_as": {"type": "str"},
                "precision_timers": {"type": "bool"},
                "preference": {"type": "str"},
                "remove_private": {
                    "options": {
                        "all": {"type": "bool"},
                        "no_peer_loop_check": {"type": "bool"},
                        "replace": {
                            "options": {
                                "nearest": {"type": "bool"},
                                "set": {"type": "bool"},
                            },
                            "type": "dict",
                        },
                        "set": {"type": "bool"},
                    },
                    "type": "dict",
                },
                "rfc6514_compliant_safi129": {"type": "bool"},
                "route_server_client": {"type": "bool"},
                "send_addpath_optimization": {"type": "bool"},
                "snmp_options": {
                    "options": {
                        "backward_traps_only_from_established": {
                            "type": "bool"
                        },
                        "emit_inet_address_length_in_oid": {"type": "bool"},
                    },
                    "type": "dict",
                },
                "sr_preference_override": {"type": "str"},
                "stale_labels_holddown_period": {"type": "int"},
                "tcp_aggressive_transmission": {"type": "bool"},
                "tcp_mss": {"type": "int"},
                "traceoptions": {
                    "options": {
                        "file": {
                            "options": {
                                "file_name": {"type": "str"},
                                "files": {"type": "int"},
                                "no_world_readable": {"type": "bool"},
                                "size": {"type": "int"},
                                "world_readable": {"type": "bool"},
                            },
                            "type": "dict",
                        },
                        "flag": {
                            "options": {
                                "byte_as": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "add_path": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "all": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "bfd": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "damping": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "filter": {
                                            "options": {
                                                "match_on_prefix": {
                                                    "type": "bool"
                                                },
                                                "policy": {"type": "str"},
                                                "set": {"type": "bool"},
                                            },
                                            "type": "dict",
                                        },
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "egress_te": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "general": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "graceful_restart": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "keepalive": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "normal": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "nsr_synchronization": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "open": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "packets": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "policy": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "refresh": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "route": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "filter": {
                                            "options": {
                                                "match_on_prefix": {
                                                    "type": "bool"
                                                },
                                                "policy": {"type": "str"},
                                                "set": {"type": "bool"},
                                            },
                                            "type": "dict",
                                        },
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "state": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "thread_io": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "thread_update_io": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "timer": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                                "update": {
                                    "options": {
                                        "detail": {"type": "bool"},
                                        "disable": {"type": "bool"},
                                        "receive": {"type": "bool"},
                                        "send": {"type": "bool"},
                                        "set": {"type": "bool"},
                                    },
                                    "type": "dict",
                                },
                            },
                            "type": "dict",
                        },
                    },
                    "type": "dict",
                },
                "traffic_statistics_labeled_path": {
                    "options": {
                        "file": {
                            "options": {
                                "file_name": {"type": "str"},
                                "files": {"type": "int"},
                                "no_world_readable": {"type": "bool"},
                                "size": {"type": "int"},
                                "world_readable": {"type": "bool"},
                            },
                            "type": "dict",
                        },
                        "interval": {"type": "int"},
                    },
                    "type": "dict",
                },
                "ttl": {"type": "int"},
                "unconfigured_peer_graceful_restart": {"type": "bool"},
                "vpn_apply_export": {"type": "bool"},
            },
            "type": "dict",
        },
        "running_config": {"type": "str"},
        "state": {
            "choices": [
                "merged",
                "replaced",
                "purged",
                "deleted",
                "gathered",
                "parsed",
                "rendered",
            ],
            "default": "merged",
            "type": "str",
        },
    }  # pylint: disable=C0301
